<?PHP
/** Classe mre (attributs & mthodes communes)**/
 
abstract class ATTRIBUTE{
	//attributs
	protected $type;	//'string' Type
	protected $name;	//'string' Nom
	protected $value;	//'string' valeur du champ
	protected $disabled;//'bool' Etat d'activit du champ (false==actif)
	protected $css;		//'string' style CSS
	protected $source;	//'string' ajoute ce que l'on veux dans la balise html
	protected $label;	//'string' Texte optionnel avant l'objet ( ajouter 'AF_' dans la
						// chaine pour situer le texte aprs l'objet.
						// ajouter 'LB_'  dans la chaine pour encapsuler avec <label></label>
	
	//variable fonction WRITE()
	protected $ligne_label = '';
	protected $ligne_input = '';
	protected $ligne_source = '';
	protected $ligne_total = '';
	protected $label_fin = false;

					
	function __construct(){
	}

	//renvoie le nom de l'lment (attributs privs)
	function name(){
		return $this->name;
	}	
	
	
	/*trie & dcompose une suite de noms (d'une chaine ou tableau) pour les labels
	*	TAG : return 1 == AF_  return 2 == LB_  return 3 == AF_LB_
	*/
	protected function multilabel( $lab ){
		// pour le return
		$r = 0;
		$rr = 0 ;
		// pour compter le nombre de liblls
		$x = 0;
		$this->label = array();
		$this->value = array();
		
		//version tableau
		if( is_array( $lab ) ){
	
			foreach( $lab as $elem ){
				//teste si AF_ existe dans la chane
				if( is_int( strpos( $elem, 'AF_' ) ) ) {			
					$r = 1;
					$elem = str_replace( 'AF_', '', $elem ) ;
				}
				
				//teste si LB_ existe dans la chane
				if( is_int( strpos( $elem, 'LB_' ) ) ) {			
					$rr = 2;
					$elem = str_replace( 'LB_', '', $elem ) ;
				}
				
				//remplie le tableau des libells
				if( $elem != '' ){
					array_push( $this->label, htmlentities( $elem ) );
					array_push( $this->value, $x+1 );
					$x++;
				}	
			}
			
		}
		//version chaine de caractres
		if( is_string( $lab ) ){

			//teste si AF_ existe dans la chane
			if( is_int( strpos( $lab, 'AF_' ) ) ) {			
				$r = 1;
				$lab = str_replace( 'AF_', '', $lab );
			}
			
			//teste si LB_ existe dans la chane
			if( is_int( strpos( $lab, 'LB_' ) ) ) {			
				$rr = 2;
				$lab = str_replace( 'LB_', '', $lab );
			}	
	
			$lab = htmlentities( $lab );
			
			//trie des noms pour les diffrents boutons "radios" (dtermine leur nombre aussi)
			$this->label = explode('/', $lab );
		
			//supression des lments vides ventuels & incrmentation pour la valeur retour $_POST 
			foreach( $this->label as $key => $element ){
				
				if( $element == '' ){
					unset( $this->label[ $key ] );
				}else{
					$this->value[ $x ] = $x+1;
					$x++;
				}
			}
			
		}
		
		//pas assez de noms pour former le minimum de 2 (model par dfaut)
		if( $x < 2 ){
			unset( $this->label );
			unset( $this->value );
			//$this->label[0] = 'Default';
			//$this->label[1] = 'Default';
			//return codage sur 2 chiffes pour instancier dans la class fille un nom spcifique
			$r = 0;
			$rr = 10;
			$this->value[0] = 1;
			$this->value[1] = 2;
		}		
		
		return ( $r + $rr );
	}
	
	/*trie & dcompose une suite de noms (d'une chaine ou tableau) pour les value
	*
	*/
	protected function multivalue( $val ){

		// pour compter le nombre de valeurs
		$tmp = array();

		//version tableau
		if( is_array( $val )  ){
			
			//efface les lments vides du tableaux
			foreach( $val as $key=> $elem ){
				
				if( $elem == '' ){
					unset( $val[ $key ] );
				}	
			}	
			
			if( count( $this->label ) == count( $val ) ){
				$this->value = $val;
				return true;
			}			
		}
		//version chaine de caractres
		if( is_string( $val ) ){
		
			$val = htmlentities( $val );

			//trie les valeurs de retour des  boutons radios (dtermine leur nombre aussi)
			$tmp = explode('/', $val );

			//efface les lments vides du tableaux
			foreach( $tmp as $key=> $elem ){
				if( $elem == '' ){
					unset( $tmp[ $key ] );
				}	
			}

			if( count( $this->label ) == count( $tmp ) ){
				$this->value = $tmp;
				return true;
			}
		}
	
		return false;
	}
	
	//instancie les variables TAG (AF_ LB_) de la class fille
	protected function instancitag( $t ){ 
	
		if(  $t == 1 ){
			$this->af_ = true;
		}elseif( $t == 2 ){
			$this->lb_ = true;
		}elseif( $t == 3 ){
			$this->af_ = true;
			$this->lb_ = true;
		}else{
			$this->af_ = false;
			$this->lb_ = false;
		}
	}
	
	//instancie la variable CSS retour false en cas d'erreur
	protected function instancicss( $t ){

		//gestion du CSS
		if( $t !== '' ) {
			if( strpos( $t, '#' ) === 0 ){
				$t = str_replace( '#', '', $t );
				return ' id="'.rtrim( $t ).'"';
			}
			
			if( strpos( $t, '.' ) === 0 ){
				$t = str_replace( '.', '', $t );
				return ' class="'.rtrim( $t ).'"';
			}
			
			return false;
		}else{
			return '';
		}
	}
	
	//instancie la variable SOURCE
	protected function instancisource( $t ){
	
		if( is_string( $t ) ){
			$t = str_replace( '>', '', $t );
			$t = str_replace( '<', '', $t );
			return $t;
		}
		
		if( $t === '' ){
			return '';
		}	
		
		return false;
	}

	/*change les attributs privs des objets forms
	*
	*	function attribute( $tag, $valeur );
	*/
	function attribute( $attrib = '', $val = '' ){
		
		switch( strtolower( $attrib ) ){

			case 'value':
				$this->value = htmlentities( $val );
				break;
			case 'name':
				$val = trim( $val );
				if( $val !='' ){
					$this->name = $val;
					break;
				}
				trigger_error( '*ATTRIBUTE=>NAME bad argument*', E_USER_WARNING );
				break;
			case 'disabled':
				if( $val === true || $val === false ){
					$this->disabled = $val;
					break;
				}
				trigger_error( '*ATTRIBUTE=>DISABLED bad argument*', E_USER_WARNING );
				break;
			case 'label':
				$this->label = htmlentities( $val );
				break;
			case 'css':				
				$this->css = $this->instancicss( $val );
				if( $this->css === false ){
					$this->css = '';
					trigger_error( '*ATTRIBUTE=>CSS bad argument*', E_USER_WARNING );
					break;
				}
				break;
			case 'source':
				$this->source = $this->instancisource( $val );			
				if( $this->source === false ){
					$this->source = '';
					trigger_error( '*ATTRIBUTE=>SOURCE bad argument*', E_USER_WARNING );
					break;
				}
				break;
			default:
				trigger_error( '*ATTRIBUTE bad argument*', E_USER_WARNING );
				break;
		}
	}	


	//crit le rsultat en HTML
	protected function write( $screen = '' ){

		//balise label
		if( $this->label_fin == true ) {			
			$this->label = str_replace( 'LB_', '', $this->label );
			
			$this->ligne_label = '<label';

			if( $this->css != '' ){
				$this->ligne_label .= ' '.$this->css;
			}
			if( $this->source != '' ){
				$this->ligne_label .= ' '.$this->source;
			}
	
			$this->ligne_label .= '>';
		}		
		
		//texte du label (BEFOR par dfaut)
		if( !is_int( strpos( $this->label, 'AF_' ) )   ){
			$this->ligne_label .= $this->label;
		}
		
		/*
		* PARTIE DANS LA CLASS FILLE ecrit ici
		*/
				
		//ecriture html
		$this->ligne_total = $this->ligne_label .= $this->ligne_input;
		
		//texte du label si (AFTER)
		if( is_int( strpos( $this->label, 'AF_' ) ) ){
			$this->ligne_total .= $this->label = str_replace( 'AF_', '', $this->label ); 
		}
		
		//fermeture si label
		if( $this->label_fin ){
			$this->ligne_total .= '</label>';
		}
		
		//criture vers cran ou navigateur
		if( $screen != '' ){
			echo htmlspecialchars( $this->ligne_total );
		}else{
			echo $this->ligne_total;
		}
	}
	
}
?>